#pragma once
#include <kr2_program_api/api_v1/program_interface.h>
#include "communication/bridge/i_bridge_interface_provider.h"
#include "communication/bridge/connection_lifecycle/i_connection_factory.h"
#include "communication/bridge/proxy/i_bridge_proxy_factory.h"
#include <kr2_program_api/internals/api/console.h>

namespace spin
{
    class InterfaceProvider : public IBridgeInterfaceProvider
    {
    public:
        InterfaceProvider(boost::shared_ptr<kr2_program_api::ProgramInterface> api,
                          std::shared_ptr<IBridgeProxyFactory> bridgeProxyFactory,
                          std::shared_ptr<IConnectionFactory> connectionFactory);

        InterfaceProvider(std::shared_ptr<IBridgeProxyFactory> bridgeProxyFactory);

        std::shared_ptr<IBridgeConnectionStatusProvider> getBridgeConnectionStatusProvider() const override;
        std::shared_ptr<IToolConnectionStatusProvider> getToolConnectionStatusProvider() const override;
        std::shared_ptr<IProgramDataProvider> getProgramDataProvider() const override;
        std::shared_ptr<IToolController> getToolController() const override;
        std::shared_ptr<IBridgeConfigurator> getIBridgeConfigurator() const override;
        std::shared_ptr<IBridgeConnector> getBridgeConnector() const override;
        std::shared_ptr<ISecondaryBridgeConnector> getSecondaryBridgeConnector() const override;

    private:
        std::shared_ptr<IBridgeProxy> bridgeProxy_;
    };
} // namespace spin
